/* xvSolitaire, version 1.0
 * Copyright (C) 1993  Andreas Almroth
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#define YELLOW     0
#define BLACK      2
#define BLUE       1
#define NUM_COLORS 3

static Xv_singlecolor colors[] = {
  {255,255,  0},
  {  0,  0,255},
  {  0,  0,  0},
};

#define bild3_width 48
#define bild3_height 40

#ifdef LINUX
static char bild3_bits[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x7f, 0x00, 0x00, 
  0x03, 0x00, 0xff, 0xff, 0x00, 0x80, 0x0f, 0x00, 0xff, 0xff, 0x00, 0xe0, 
  0x3f, 0x00, 0xff, 0xff, 0x00, 0xf8, 0x7f, 0x00, 0xff, 0xff, 0x00, 0xfc, 
  0xff, 0x00, 0xff, 0xff, 0x00, 0xfe, 0xff, 0x01, 0xff, 0xff, 0x00, 0xff, 
  0xff, 0x03, 0xff, 0xff, 0x80, 0xff, 0xff, 0x07, 0xff, 0xff, 0xc0, 0xff, 
  0xff, 0x07, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xe0, 0xff, 
  0xff, 0x0f, 0xff, 0xff, 0xe0, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 
  0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 
  0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 
  0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 
  0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 
  0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 
  0xff, 0x1f, 0xff, 0xff, 0xf0, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xe0, 0xff, 
  0xff, 0x0f, 0xff, 0xff, 0xe0, 0xff, 0xff, 0x07, 0xff, 0xff, 0xc0, 0xff, 
  0xff, 0x07, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x03, 0xff, 0xff, 0x80, 0xff, 
  0xff, 0x01, 0xff, 0xff, 0x00, 0xff, 0xff, 0x00, 0xff, 0xff, 0x00, 0xfe, 
  0x7f, 0x00, 0xff, 0xff, 0x00, 0xfc, 0x3f, 0x00, 0xff, 0xff, 0x00, 0xf8, 
  0x0f, 0x00, 0xff, 0xff, 0x00, 0xe0, 0x03, 0x00, 0xff, 0xff, 0x00, 0x80, 
  0x00, 0x00, 0xfc, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
  };
#else
static char bild3_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xfc, 0x00, 0x00, 
   0x00, 0x03, 0xff, 0xff, 0x80, 0x00, 0x00, 0x0f, 0xff, 0xff, 0xe0, 0x00, 
   0x00, 0x3f, 0xff, 0xff, 0xf8, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xfc, 0x00, 
   0x00, 0xff, 0xff, 0xff, 0xfe, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0x00, 
   0x03, 0xff, 0xff, 0xff, 0xff, 0x80, 0x07, 0xff, 0xff, 0xff, 0xff, 0xc0, 
   0x07, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0f, 0xff, 0xff, 0xff, 0xff, 0xe0, 
   0x0f, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 
   0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 
   0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 
   0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 
   0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 
   0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 
   0x1f, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x0f, 0xff, 0xff, 0xff, 0xff, 0xe0, 
   0x0f, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x07, 0xff, 0xff, 0xff, 0xff, 0xc0, 
   0x07, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x03, 0xff, 0xff, 0xff, 0xff, 0x80, 
   0x01, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfe, 0x00, 
   0x00, 0x7f, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x3f, 0xff, 0xff, 0xf8, 0x00, 
   0x00, 0x0f, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x03, 0xff, 0xff, 0x80, 0x00, 
   0x00, 0x00, 0x7f, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
#endif

#define tom_width 48
#define tom_height 40
static char tom_bits[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  };


#ifdef MONO_SCREEN
#define mono_width 48
#define mono_height 40
#ifdef LINUX
static char mono_bits[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x7f, 0x00, 0x00, 
  0x03, 0x00, 0xff, 0xff, 0x00, 0x80, 0x0f, 0x00, 0xff, 0xff, 0x00, 0xe0, 
  0x3f, 0x00, 0xff, 0xff, 0x00, 0xf8, 0x7f, 0x00, 0xff, 0xff, 0x00, 0xfc, 
  0xff, 0x00, 0xff, 0xff, 0x00, 0xfe, 0xff, 0x01, 0xff, 0xfe, 0x00, 0xff, 
  0xff, 0x03, 0x0f, 0xe0, 0x80, 0xff, 0xff, 0x07, 0x03, 0x80, 0xc0, 0xff, 
  0xff, 0x07, 0x01, 0x00, 0xc0, 0xff, 0xfe, 0x0f, 0x00, 0x00, 0xe0, 0xff, 
  0xfe, 0x0f, 0x00, 0x00, 0xe0, 0xff, 0xfc, 0x1f, 0x00, 0x00, 0xf0, 0x7f, 
  0xfc, 0x1f, 0x00, 0x00, 0xf0, 0x7f, 0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 
  0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 
  0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x1f, 
  0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 
  0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 0xf8, 0x1f, 0x00, 0x00, 0xf0, 0x3f, 
  0xfc, 0x1f, 0x00, 0x00, 0xf0, 0x7f, 0xfc, 0x0f, 0x00, 0x00, 0xe0, 0x7f, 
  0xfe, 0x0f, 0x00, 0x00, 0xe0, 0xff, 0xfe, 0x07, 0x00, 0x00, 0xc0, 0xff, 
  0xff, 0x07, 0x01, 0x00, 0xc0, 0xff, 0xff, 0x03, 0x03, 0x80, 0x80, 0xff, 
  0xff, 0x01, 0x0f, 0xe0, 0x00, 0xff, 0xff, 0x00, 0xff, 0xff, 0x00, 0xfe, 
  0x7f, 0x00, 0xff, 0xff, 0x00, 0xfc, 0x3f, 0x00, 0xff, 0xff, 0x00, 0xf8, 
  0x0f, 0x00, 0xff, 0xff, 0x00, 0xe0, 0x03, 0x00, 0xff, 0xff, 0x00, 0x80, 
  0x00, 0x00, 0xfc, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  };
#else
static char mono_bits[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xfc, 0x00, 0x00, 
  0x00, 0x03, 0xff, 0xff, 0x80, 0x00, 0x00, 0x0f, 0xff, 0xff, 0xe0, 0x00, 
  0x00, 0x3f, 0xff, 0xff, 0xf8, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xfc, 0x00, 
  0x00, 0xff, 0xff, 0xff, 0xfe, 0x00, 0x01, 0xff, 0xfe, 0xff, 0xff, 0x00, 
  0x03, 0xff, 0xe0, 0x0f, 0xff, 0x80, 0x07, 0xff, 0x80, 0x03, 0xff, 0xc0, 
  0x07, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x0f, 0xfe, 0x00, 0x00, 0xff, 0xe0, 
  0x0f, 0xfe, 0x00, 0x00, 0xff, 0xe0, 0x1f, 0xfc, 0x00, 0x00, 0x7f, 0xf0, 
  0x1f, 0xfc, 0x00, 0x00, 0x7f, 0xf0, 0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 
  0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 
  0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 0x1f, 0xf8, 0x00, 0x00, 0x1f, 0xf0, 
  0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 
  0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 0x1f, 0xf8, 0x00, 0x00, 0x3f, 0xf0, 
  0x1f, 0xfc, 0x00, 0x00, 0x7f, 0xf0, 0x0f, 0xfc, 0x00, 0x00, 0x7f, 0xe0, 
  0x0f, 0xfe, 0x00, 0x00, 0xff, 0xe0, 0x07, 0xfe, 0x00, 0x00, 0xff, 0xc0, 
  0x07, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x03, 0xff, 0x80, 0x03, 0xff, 0x80, 
  0x01, 0xff, 0xe0, 0x0f, 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0xfe, 0x00, 
  0x00, 0x7f, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x3f, 0xff, 0xff, 0xf8, 0x00, 
  0x00, 0x0f, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x03, 0xff, 0xff, 0x80, 0x00, 
  0x00, 0x00, 0x7f, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  };
#endif
#endif

static char info[] = {
"xvSolitaire Version 1.0 - An enchanting board game\n\
Copyright (C) 1993  Andreas Almroth\n\n\
This program is free software; you can redistribute it and/or\n\
modify it under the terms of the GNU General Public License\n\
as published by the Free Software Foundation; either version 2\n\
of the License, or (at your option) any later version.\n\n\
This program is distributed in the hope that it will be useful,\n\
but WITHOUT ANY WARRANTY; without even the implied warranty of\n\
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n\
GNU General Public License for more details.\n\n\
You should have received a copy of the GNU General Public License\n\
along with this program; if not, write to the Free Software\n\
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.\n\n\
The author can be reached at:\n\
EMail: almroth@lysator.liu.se   or    SMail: Andreas Almroth\n\
                                             Arrendegatan 88\n\
                                             58331 LINKOPING\n\
                                             SWEDEN\n\n\
Rules\n\
=====\n\
Your goal is to remove as many bricks as possible from the\n\
board. You can jump in all direction. To remove one brick\n\
you must choose a adjacent brick and move it to a adjacent\n\
free spot to the brick you want to remove.\n"};


